unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, ComCtrls, ExtDlgs,
  UnitV, Unit2, Unit3 ;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    ColorDialog1: TColorDialog;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private 錾 }
    imgx,imgy : integer ;
    penType : integer ;
    penSize : integer ;
    penColor: integer ;
    penDrawMode : integer ;
    procedure PenDraw(X,Y:integer) ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   imgx := 320 ;
   imgy := 240 ;
   penType  := 0 ;
   penSize  := 1 ;
   penColor := clBlack ;
   penDrawMode := 0 ;

   Image1.Picture := nil ;
   Image1.Width  := imgx ;
   Image1.Height := imgy ;
   GCLS(Image1.Canvas,imgx,imgy);
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Image1.Picture := nil ;
end;

// VK쐬
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   Form2.P_X := imgx ;
   Form2.P_Y := imgy ;
   Form2.ShowModal ;
   if (Form2.OKflag) then begin
      imgx := Form2.P_X ;
      imgy := Form2.P_Y ;

      Image1.Picture := nil ;
      Image1.Width  := imgx ;
      Image1.Height := imgy ;
      GCLS(Image1.Canvas,imgx,imgy);
   end;
end;

// J
procedure TForm1.SpeedButton2Click(Sender: TObject);
var
   fn : string ;
begin
   if (OpenPictureDialog1.Execute) then begin
      fn := OpenPictureDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '.BMP') then begin
         try
            Image1.Picture := nil ;
            Image1.Picture.LoadFromFile(fn);
            imgx := Image1.Picture.Width  ;
            imgy := Image1.Picture.Height ;
            Image1.Width   := imgx ;
            Image1.Height  := imgy ;
         except
            ;
         end;
      end;
   end;
end;

// ۑ
procedure TForm1.SpeedButton3Click(Sender: TObject);
var
   fn : string ;
begin
   if (SavePictureDialog1.Execute) then begin
      fn := SavePictureDialog1.FileName ;
      if (AnsiUpperCase(ExtractFileExt(fn)) = '.BMP') then begin
         try
            Image1.Picture.SaveToFile(fn);
         except
            ;
         end;
      end;
   end;
end;

// y
procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
   Form3.P_T := penType ;
   Form3.P_S := penSize ;
   Form3.ShowModal ;
   if (Form3.OKflag) then begin
      penType := Form3.P_T ;
      penSize := Form3.P_S ;
   end;
end;

// yF
procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
   ColorDialog1.Color := penColor ;
   if (ColorDialog1.Execute) then begin
      penColor := ColorDialog1.Color ;
   end;
end;

// y}Jn
procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
   SpeedButton6.Down := True ;
   penDrawMode := 1 ;
end;

// }EXNbN
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssLeft in Shift) then begin
      if (penDrawMode > 0) then
         PenDraw(X,Y);
   end;
end;

// }EXړ
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if (ssLeft in Shift) then begin
      if (penDrawMode > 0) then
         PenDraw(X,Y) ;
   end;
end;

// }s
procedure TForm1.PenDraw(X,Y:integer) ;
var
   s1,s2 : integer ;
begin
   Case (penDrawMode) of
   1: begin
         s1 := penSize div 2 ;
         s2 := penSize - s1 ;
         with Image1.Canvas do begin
            if (penSize = 1) then begin
               Pixels[X,Y] := penColor ;
               exit ;
            end;

            Pen.Mode := pmCopy ;
            Pen.Color := penColor ;
            Pen.Style := psSolid ;
            Brush.Color := penColor ;
            Case(penType)of
            0: begin // 
                  Brush.Style := bsSolid ;
                  Ellipse(X-s1,Y-s1, X+s2,Y+s2);
               end;
            1: begin // 
                  Brush.Style := bsClear ;
                  Ellipse(X-s1,Y-s1, X+s2,Y+s2);
               end;
            2: begin // 
                  Brush.Style := bsSolid ;
                  Rectangle(X-s1,Y-s1, X+s2,Y+s2);
               end;
            3: begin // 
                  Brush.Style := bsClear ;
                  Rectangle(X-s1,Y-s1, X+s2,Y+s2);
               end;
            4: begin // ^
                  MoveTo(X+s2,Y-s1);
                  LineTo(X-s1,Y+s2);
               end;
            5: begin // _
                  MoveTo(X-s1,Y-s1);
                  LineTo(X+s2,Y+s2);
               end;
            end;
         end;
      end;
   end;
end;

end.
